
#include <ArduinoBLE.h>

const int R_LED_PIN = 22;
const int G_LED_PIN = 23;
const int B_LED_PIN = 24;

int relay7SOLELEFT = 7;
int relay10PUMPLEFT = 10;


int relay8SOLEMIDDLE = 8;
int relay11PUMPMIDDLE = 11;



int relay9SOLERIGHT = 9;
int relay12PUMPRIGHT = 12;


const char* deviceServiceUuid = "19b10000-e8f2-537e-4f6c-d104768a1214";
const char* deviceServiceCharacteristicUuid = "19b10001-e8f2-537e-4f6c-d104768a1214";

String command = "";


static int dutyX = 0;
static int dutyY = 0;
static int duty1 = 0;
static int duty2 = 0;

// BLE gesture Service
BLEService gestureService(deviceServiceUuid); 

// BLE gesture Switch Characteristic 
BLEStringCharacteristic gestureCharacteristic(deviceServiceCharacteristicUuid, BLERead | BLEWrite,512);


void setup() {
 

 Serial.begin(9600);
 
 pinMode(relay7SOLELEFT, OUTPUT);
  pinMode(relay10PUMPLEFT, OUTPUT);
   
  
 pinMode(relay8SOLEMIDDLE, OUTPUT); 
 pinMode(relay11PUMPMIDDLE, OUTPUT); 
 

 pinMode(relay9SOLERIGHT, OUTPUT); 
 pinMode(relay12PUMPRIGHT, OUTPUT); 
 

  // begin ble initialization
  if (!BLE.begin()) {
   Serial.println("starting BLE ");
    while (1);
  }

  // set advertised local name and service UUID:
  BLE.setLocalName("Mini Robot 4x4 peripheral");
  BLE.setAdvertisedService(gestureService);

  // add the characteristic to the service
  gestureService.addCharacteristic(gestureCharacteristic);

  // add service
  BLE.addService(gestureService);

  // set the initial value for the characeristic:
  gestureCharacteristic.writeValue("");

  // start advertising
  BLE.advertise();

  //Serial.println("Mini Robot 4x4 peripheral");
  setColor("GREEN");
}

void loop() {
  
  // listen for BLE peripherals to connect:
  BLEDevice central = BLE.central();

  // if a central is connected to peripheral:
  if (central) {
    
    //Serial.print("Connected to central: ");
    // print the central's MAC address:
    //Serial.println(central.address());

    // while the central is still connected to peripheral:
    while (central.connected()) {
      
      // if the remote device wrote to the characteristic,
      if (gestureCharacteristic.written()) {
         command = gestureCharacteristic.value();
     Serial.print(F("commmand value:  "));
        Serial.println(command);
         sendInstruction(command);
       }
      
    }

    // when the central disconnects, print it out:
    //Serial.print(F("Disconnected from central: "));
    //Serial.println(central.address());
  }
}

void sendInstruction(String str) {


  if (str.length() == 0)
    return;
    
  // split 
  int pos = str.indexOf(",");
  int strLength = str.length();

  dutyX = str.substring(0,pos).toInt(); 
  dutyY = str.substring(pos+1,strLength).toInt(); 
 
 Serial.print(F("valor en X:  "));
 Serial.print(dutyX);
  Serial.print(F("\t valor en Y: "));
  Serial.println(dutyY);


  

    if ((dutyY >= 30) && (dutyX > -20) && (dutyX < 20)) // left
    {
    digitalWrite(relay9SOLERIGHT, HIGH);
digitalWrite(relay12PUMPRIGHT, HIGH);
digitalWrite(relay7SOLELEFT, LOW);
digitalWrite(relay10PUMPLEFT, LOW);
digitalWrite(relay8SOLEMIDDLE, LOW);
 digitalWrite(relay11PUMPMIDDLE, LOW);
setColor("RED");
    }
    else if ((dutyY <= -30) && (dutyX > -20) && (dutyX < 20)) //right
    {
      
 digitalWrite(relay7SOLELEFT, HIGH);
 digitalWrite(relay10PUMPLEFT, HIGH);
 digitalWrite(relay9SOLERIGHT, LOW);
 digitalWrite(relay12PUMPRIGHT, LOW);
 digitalWrite(relay8SOLEMIDDLE, LOW);
 digitalWrite(relay11PUMPMIDDLE, LOW);
 setColor("BLUE");

    }
    else if ((dutyX >= 20) && (dutyY > -30) && (dutyY < 30)) //back
    {digitalWrite(relay8SOLEMIDDLE, LOW);
 digitalWrite(relay11PUMPMIDDLE, LOW);
 digitalWrite(relay7SOLELEFT, LOW);
digitalWrite(relay10PUMPLEFT, LOW);
 digitalWrite(relay9SOLERIGHT, LOW);
 digitalWrite(relay12PUMPRIGHT, LOW);
 
setColor("YELLOW");
 
 
    }
    else if ((dutyX <= -20) && (dutyY > -30) && (dutyY < 30)) //foward
    {
 digitalWrite(relay8SOLEMIDDLE, HIGH);
 digitalWrite(relay11PUMPMIDDLE, HIGH);
 digitalWrite(relay7SOLELEFT, LOW);
digitalWrite(relay10PUMPLEFT, LOW);
 digitalWrite(relay9SOLERIGHT, LOW);
 digitalWrite(relay12PUMPRIGHT, LOW);
 setColor("PURPLE");
    }
    else if ((dutyY >= 30) && (dutyX >= 20)) // adelante + izquierda 
    {
    
    }
    else if ((dutyY >= 30) && (dutyX <= -20)) // adelante + derecha 
    {
  
    }
    else if ((dutyY <= -30) && (dutyX >= 20)) // atras + izquierda 
    { }
      
    else if ((dutyY <= -30) && (dutyX <= -20)) // atras + derecha 
    {
          
    }
    else
    {
     
    }

}
void setColor(String color)
{

  if (color == "RED")
  {
    digitalWrite(R_LED_PIN, LOW);  // High values -> lower brightness
    digitalWrite(G_LED_PIN, HIGH);
    digitalWrite(B_LED_PIN, HIGH);
    
  }else if (color == "GREEN")
  {
    digitalWrite(R_LED_PIN, HIGH);  // High values -> lower brightness
    digitalWrite(G_LED_PIN, LOW);
    digitalWrite(B_LED_PIN, HIGH);
    
  }else if (color == "BLUE")
  {
    digitalWrite(R_LED_PIN, HIGH);  // High values -> lower brightness
    digitalWrite(G_LED_PIN, HIGH);
    digitalWrite(B_LED_PIN, LOW);
    
  }else if (color == "PURPLE")
  {
    digitalWrite(R_LED_PIN, LOW);  // High values -> lower brightness
    digitalWrite(G_LED_PIN, HIGH);
    digitalWrite(B_LED_PIN, LOW);
  }else if (color == "YELLOW")
  {
    digitalWrite(R_LED_PIN, LOW);  // High values -> lower brightness
    digitalWrite(G_LED_PIN, LOW);
    digitalWrite(B_LED_PIN, HIGH);
    
  }        

}

  
